## containerd 1.6.20~ds1

=== debian/changelog ===
containerd (1.6.20~ds1-1+deb12u1) bookworm; urgency=medium

  * Non-maintainer upload.
  * Backport 0011-allow-test-run-in-userns.patch to fix FTBFS
    on builders with unshare (closes: #1070411)

 -- Jonathan Wiltshire <jmw@debian.org>  Wed, 15 Jan 2025 12:18:21 +0000

containerd (1.6.20~ds1-1) unstable; urgency=medium

  * New upstream version 1.6.20~ds1
  * Bump golang-github-containerd-ttrpc-dev to 1.1.1
  * Bump golang-github-opencontainers-image-spec-dev to 1.1.0~rc2-2

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 01 Apr 2023 01:27:11 +0800

=== debian/control ===
Source: containerd
Section: admin
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Tianon Gravi <tianon@debian.org>,
           Tim Potter <tpot@hpe.com>,
           Shengjing Zhu <zhsj@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               go-md2man,
               golang-any,
               golang-github-blang-semver-dev,
               golang-github-containerd-btrfs-dev (>= 0.0~git20200117.1539353~),
               golang-github-containerd-cgroups-dev (>= 0.0~git20200817.7a3c009~),
               golang-github-containerd-console-dev,
               golang-github-containerd-continuity-dev (>= 0.0~git20190827.75bee3e~),
               golang-github-containerd-fifo-dev (>= 1.0.0~),
               golang-github-containerd-go-cni-dev (>= 1.0.2~),
               golang-github-containerd-go-runc-dev (>= 0.0~git20190226.7d11b49~),
               golang-github-containerd-ttrpc-dev (>= 1.1.1~),
               golang-github-containerd-typeurl-dev,
               golang-github-containernetworking-plugins-dev,
               golang-github-containers-ocicrypt-dev,
               golang-github-coreos-bbolt-dev,
               golang-github-coreos-go-systemd-dev,
               golang-github-davecgh-go-spew-dev,
               golang-github-docker-go-events-dev,
               golang-github-docker-go-metrics-dev,
               golang-github-docker-go-units-dev,
               golang-github-emicklei-go-restful-dev,
               golang-github-fsnotify-fsnotify-dev,
               golang-github-go-logr-logr-dev,
               golang-github-gogo-googleapis-dev (>= 1.4.0~),
               golang-github-gogo-protobuf-dev (>= 1.3.0~),
               golang-github-google-go-cmp-dev,
               golang-github-google-gofuzz-dev,
               golang-github-google-uuid-dev,
               golang-github-gotestyourself-gotest.tools-dev (>= 3.0.0~),
               golang-github-grpc-ecosystem-go-grpc-prometheus-dev,
               golang-github-hashicorp-go-multierror-dev,
               golang-github-imdario-mergo-dev,
               golang-github-intel-goresctrl-dev,
               golang-github-klauspost-compress-dev,
               golang-github-moby-locker-dev,
               golang-github-moby-spdystream-dev,
               golang-github-moby-sys-dev (>= 0.0~git20220215.b8d8fab~),
               golang-github-opencontainers-go-digest-dev (>= 1.0.0~),
               golang-github-opencontainers-image-spec-dev (>= 1.1.0~rc2-2~),
               golang-github-opencontainers-runc-dev (>= 0.1.0~),
               golang-github-opencontainers-runtime-spec-dev,
               golang-github-opencontainers-selinux-dev,
               golang-github-pelletier-go-toml-dev,
               golang-github-pkg-errors-dev,
               golang-github-prometheus-client-golang-dev,
               golang-github-sirupsen-logrus-dev,
               golang-github-spf13-pflag-dev,
               golang-github-tchap-go-patricia-dev,
               golang-github-urfave-cli-dev (>= 1.22.2-4~),
               golang-github-vishvananda-netlink-dev,
               golang-go-zfs-dev,
               golang-golang-x-net-dev,
               golang-golang-x-sync-dev,
               golang-golang-x-sys-dev,
               golang-golang-x-time-dev,
               golang-google-grpc-dev (>= 1.30),
               golang-gopkg-inf.v0-dev,
               golang-k8s-klog-dev (>= 2.30.0~),
               golang-k8s-sigs-structured-merge-diff-dev,
               golang-k8s-sigs-yaml-dev,
               golang-opentelemetry-otel-dev,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://containerd.io/
Vcs-Git: https://salsa.debian.org/go-team/packages/containerd.git
Vcs-Browser: https://salsa.debian.org/go-team/packages/containerd
XS-Go-Import-Path: github.com/containerd/containerd
Testsuite: autopkgtest-pkg-go

Package: containerd
Architecture: linux-any
Breaks: docker.io (<< 1.12),
Depends: runc (>= 0.1.0~),
         ${misc:Depends},
         ${shlibs:Depends},
Suggests: containernetworking-plugins,
Built-Using: ${misc:Built-Using},
Description: open and reliable container runtime
 Containerd is an industry-standard container runtime with an emphasis on
 simplicity, robustness and portability. It is available as a daemon for
 Linux and Windows, which can manage the complete container life cycle of
 its host system: image transfer and storage, container execution and
 supervision, low-level storage and network attachments, etc.
 .
 Containerd is designed to be embedded into a larger system, rather than
 being used directly by developers or end-users.
 .
 This package contains the binaries.

Package: golang-github-containerd-containerd-dev
Architecture: all
Section: golang
Depends: golang-github-containerd-btrfs-dev (>= 0.0~git20200117.1539353~),
         golang-github-containerd-cgroups-dev (>= 0.0~git20200817.7a3c009~),
         golang-github-containerd-console-dev,
         golang-github-containerd-continuity-dev (>= 0.0~git20190827.75bee3e~),
         golang-github-containerd-fifo-dev (>= 1.0.0~),
         golang-github-containerd-go-cni-dev (>= 1.0.2~),
         golang-github-containerd-go-runc-dev (>= 0.0~git20190226.7d11b49~),
         golang-github-containerd-ttrpc-dev (>= 1.1.1~),
         golang-github-containerd-typeurl-dev,
         golang-github-containernetworking-plugins-dev,
         golang-github-coreos-bbolt-dev,
         golang-github-docker-go-events-dev,
         golang-github-docker-go-metrics-dev,
         golang-github-docker-go-units-dev,
         golang-github-gogo-googleapis-dev (>= 1.4.0~),
         golang-github-gogo-protobuf-dev (>= 1.3.0~),
         golang-github-google-uuid-dev,
         golang-github-gotestyourself-gotest.tools-dev (>= 3.0.0~),
         golang-github-grpc-ecosystem-go-grpc-prometheus-dev,
         golang-github-hashicorp-go-multierror-dev,
         golang-github-imdario-mergo-dev,
         golang-github-intel-goresctrl-dev,
         golang-github-klauspost-compress-dev,
         golang-github-moby-locker-dev,
         golang-github-moby-sys-dev (>= 0.0~git20220215.b8d8fab~),
         golang-github-opencontainers-go-digest-dev (>= 1.0.0~),
         golang-github-opencontainers-image-spec-dev (>= 1.1.0~rc2-2~),
         golang-github-opencontainers-runc-dev (>= 0.1.0~),
         golang-github-opencontainers-runtime-spec-dev,
         golang-github-opencontainers-selinux-dev,
         golang-github-pelletier-go-toml-dev,
         golang-github-prometheus-client-golang-dev,
         golang-github-sirupsen-logrus-dev,
         golang-github-urfave-cli-dev (>= 1.22.2~),
         golang-golang-x-net-dev,
         golang-golang-x-sync-dev,
         golang-golang-x-sys-dev,
         golang-google-grpc-dev (>= 1.30),
         golang-opentelemetry-otel-dev,
         ${misc:Depends},
Description: open and reliable container runtime (development files)
 Containerd is an industry-standard container runtime with an emphasis on
 simplicity, robustness and portability. It is available as a daemon for
 Linux and Windows, which can manage the complete container life cycle of
 its host system: image transfer and storage, container execution and
 supervision, low-level storage and network attachments, etc.
 .
 Containerd is designed to be embedded into a larger system, rather than
 being used directly by developers or end-users.
 .
 This package provides development files.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

PKG        := github.com/containerd/containerd
GO_LDFLAGS += -X $(PKG)/version.Version=$(DEB_VERSION_UPSTREAM)
GO_LDFLAGS += -X $(PKG)/version.Revision=$(DEB_VERSION)

EXCLUDES += cmd/protoc-gen-gogoctrd cmd/containerd-stress
EXCLUDES += runtime/v2/example/cmd
EXCLUDES += integration
EXCLUDES += tracing/plugin

# pkg/cri/server tests needs permission in schroot
# EXCLUDES += pkg/cri/server

# Exclude extra files in -dev pacakge to make it slimmer.
EXTRA_EXCLUDES += vendor
EXTRA_EXCLUDES += $(wildcard cmd/*/*.go)
EXTRA_EXCLUDES += $(filter-out pkg/cri/annotations,$(wildcard pkg/cri/*))

export DH_GOLANG_EXCLUDES := $(EXCLUDES)

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_auto_build:
	dh_auto_build -- -ldflags '$(GO_LDFLAGS)'

ifeq (,$(AUTOPKGTEST_TMP))
execute_after_dh_auto_build:
	mkdir -p man
	make man/containerd-config.8
	make man/containerd-config.toml.5
	_build/bin/gen-manpages containerd.8 man
	_build/bin/gen-manpages ctr.8 man
	rm -vf _build/bin/gen-manpages

	sed 's|/usr/local/bin|/usr/bin|' containerd.service > debian/containerd.service
	mkdir -vp debian/bash-completion
	install -m644 -T /usr/share/gocode/src/github.com/urfave/cli/autocomplete/bash_autocomplete \
		debian/bash-completion/ctr
	mkdir -vp debian/zsh-completion
	sed 's|$$PROG|ctr|g' /usr/share/gocode/src/github.com/urfave/cli/autocomplete/zsh_autocomplete > \
		debian/zsh-completion/_ctr
endif

override_dh_auto_install:
	DH_GOLANG_EXCLUDES="$(EXCLUDES) $(EXTRA_EXCLUDES)" dh_auto_install

=== debian/tests/control ===
Tests: integration
Depends: ca-certificates,
         containerd,
         lsof,
         @builddeps@,
Restrictions: allow-stderr, needs-root, needs-internet, isolation-container, flaky
# Integration test uses k8s.gcr.io/pause:3.5 image
# See the supported architectures for this image:
# $ curl https://k8s.gcr.io/v2/pause/manifests/3.2
Architecture: amd64, arm64, armel, armhf, ppc64el, s390x

Tests: cri-integration
Depends: ca-certificates,
         containerd,
         containernetworking-plugins,
         procps,
         @builddeps@,
Restrictions: allow-stderr, needs-root, needs-internet, isolation-container, flaky
Architecture: amd64, arm64, ppc64el

Tests: build-only
Depends: dh-golang,
         golang-any,
         golang-github-containerd-containerd-dev,
Restrictions: allow-stderr

## containerd 1.6.24~ds1

=== Makefile ===
#   Copyright The containerd Authors.

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.


# Go command to use for build
GO ?= go
INSTALL ?= install

# Root directory of the project (absolute path).
ROOTDIR=$(dir $(abspath $(lastword $(MAKEFILE_LIST))))

# Base path used to install.
# The files will be installed under `$(DESTDIR)/$(PREFIX)`.
# The convention of `DESTDIR` was changed in containerd v1.6.
PREFIX        ?= /usr/local
DATADIR       ?= $(PREFIX)/share
MANDIR        ?= $(DATADIR)/man

TEST_IMAGE_LIST ?=

# Used to populate variables in version package.
VERSION ?= $(shell git describe --match 'v[0-9]*' --dirty='.m' --always)
REVISION=$(shell git rev-parse HEAD)$(shell if ! git diff --no-ext-diff --quiet --exit-code; then echo .m; fi)
PACKAGE=github.com/containerd/containerd
SHIM_CGO_ENABLED ?= 0

ifneq "$(strip $(shell command -v $(GO) 2>/dev/null))" ""
	GOOS ?= $(shell $(GO) env GOOS)
	GOARCH ?= $(shell $(GO) env GOARCH)
else
	ifeq ($(GOOS),)
		# approximate GOOS for the platform if we don't have Go and GOOS isn't
		# set. We leave GOARCH unset, so that may need to be fixed.
		ifeq ($(OS),Windows_NT)
			GOOS = windows
		else
			UNAME_S := $(shell uname -s)
			ifeq ($(UNAME_S),Linux)
				GOOS = linux
			endif
			ifeq ($(UNAME_S),Darwin)
				GOOS = darwin
			endif
			ifeq ($(UNAME_S),FreeBSD)
				GOOS = freebsd
			endif
		endif
	else
		GOOS ?= $$GOOS
		GOARCH ?= $$GOARCH
	endif
endif

ifndef GODEBUG
	EXTRA_LDFLAGS += -s -w
	DEBUG_GO_GCFLAGS :=
	DEBUG_TAGS :=
else
	DEBUG_GO_GCFLAGS := -gcflags=all="-N -l"
	DEBUG_TAGS := static_build
endif

WHALE = "🇩"
ONI = "👹"

RELEASE=containerd-$(VERSION:v%=%)-${GOOS}-${GOARCH}
CRIRELEASE=cri-containerd-$(VERSION:v%=%)-${GOOS}-${GOARCH}
CRICNIRELEASE=cri-containerd-cni-$(VERSION:v%=%)-${GOOS}-${GOARCH}

PKG=github.com/containerd/containerd

# Project binaries.
COMMANDS=ctr containerd containerd-stress
MANPAGES=ctr.8 containerd.8 containerd-config.8 containerd-config.toml.5

ifdef BUILDTAGS
    GO_BUILDTAGS = ${BUILDTAGS}
endif
GO_BUILDTAGS ?=
GO_BUILDTAGS += ${DEBUG_TAGS}
ifneq ($(STATIC),)
	GO_BUILDTAGS += osusergo netgo static_build
endif
GO_TAGS=$(if $(GO_BUILDTAGS),-tags "$(strip $(GO_BUILDTAGS))",)

GO_LDFLAGS=-ldflags '-X $(PKG)/version.Version=$(VERSION) -X $(PKG)/version.Revision=$(REVISION) -X $(PKG)/version.Package=$(PACKAGE) $(EXTRA_LDFLAGS)
ifneq ($(STATIC),)
	GO_LDFLAGS += -extldflags "-static"
endif
GO_LDFLAGS+='

SHIM_GO_LDFLAGS=-ldflags '-X $(PKG)/version.Version=$(VERSION) -X $(PKG)/version.Revision=$(REVISION) -X $(PKG)/version.Package=$(PACKAGE) -extldflags "-static" $(EXTRA_LDFLAGS)'

# Project packages.
PACKAGES=$(shell $(GO) list ${GO_TAGS} ./... | grep -v /vendor/ | grep -v /integration)
API_PACKAGES=$(shell (cd api && $(GO) list ${GO_TAGS} ./... | grep -v /vendor/ | grep -v /integration))
NON_API_PACKAGES=$(shell $(GO) list ${GO_TAGS} ./... | grep -v /vendor/ | grep -v /integration | grep -v "containerd/api")
TEST_REQUIRES_ROOT_PACKAGES=$(filter \
    ${PACKAGES}, \
    $(shell \
	for f in $$(git grep -l testutil.RequiresRoot | grep -v Makefile); do \
		d="$$(dirname $$f)"; \
		[ "$$d" = "." ] && echo "${PKG}" && continue; \
		echo "${PKG}/$$d"; \
	done | sort -u) \
    )

ifdef SKIPTESTS
    PACKAGES:=$(filter-out ${SKIPTESTS},${PACKAGES})
    TEST_REQUIRES_ROOT_PACKAGES:=$(filter-out ${SKIPTESTS},${TEST_REQUIRES_ROOT_PACKAGES})
endif

#Replaces ":" (*nix), ";" (windows) with newline for easy parsing
GOPATHS=$(shell echo ${GOPATH} | tr ":" "\n" | tr ";" "\n")

TESTFLAGS_RACE=
GO_BUILD_FLAGS=
# See Golang issue re: '-trimpath': https://github.com/golang/go/issues/13809
GO_GCFLAGS=$(shell				\
	set -- ${GOPATHS};			\
	echo "-gcflags=-trimpath=$${1}/src";	\
	)

BINARIES=$(addprefix bin/,$(COMMANDS))

#include platform specific makefile
-include Makefile.$(GOOS)

# Flags passed to `go test`
TESTFLAGS ?= $(TESTFLAGS_RACE) $(EXTRA_TESTFLAGS)
TESTFLAGS_PARALLEL ?= 8

# Use this to replace `go test` with, for instance, `gotestsum`
GOTEST ?= $(GO) test

OUTPUTDIR = $(join $(ROOTDIR), _output)
CRIDIR=$(OUTPUTDIR)/cri

.PHONY: clean all AUTHORS build binaries test integration generate protos checkprotos coverage ci check help install uninstall vendor release mandir install-man genman install-cri-deps cri-release cri-cni-release cri-integration install-deps bin/cri-integration.test
.DEFAULT: default

# Forcibly set the default goal to all, in case an include above brought in a rule definition.
.DEFAULT_GOAL := all

all: binaries

check: proto-fmt ## run all linters
	@echo "$(WHALE) $@"
	GOGC=75 golangci-lint run

ci: check binaries checkprotos coverage coverage-integration ## to be used by the CI

AUTHORS: .mailmap .git/HEAD
	git log --format='%aN <%aE>' | sort -fu > $@

generate: protos
	@echo "$(WHALE) $@"
	@PATH="${ROOTDIR}/bin:${PATH}" $(GO) generate -x ${PACKAGES}

protos: bin/protoc-gen-gogoctrd ## generate protobuf
	@echo "$(WHALE) $@"
	@find . -path ./vendor -prune -false -o -name '*.pb.go' | xargs rm
	$(eval TMPDIR := $(shell mktemp -d))
	@mv ${ROOTDIR}/vendor ${TMPDIR}
	@(cd ${ROOTDIR}/api && PATH="${ROOTDIR}/bin:${PATH}" protobuild --quiet ${API_PACKAGES})
	@(PATH="${ROOTDIR}/bin:${PATH}" protobuild --quiet ${NON_API_PACKAGES})
	@mv ${TMPDIR}/vendor ${ROOTDIR}
	@rm -rf ${TMPDIR}

check-protos: protos ## check if protobufs needs to be generated again
	@echo "$(WHALE) $@"
	@test -z "$$(git status --short | grep ".pb.go" | tee /dev/stderr)" || \
		((git diff | cat) && \
		(echo "$(ONI) please run 'make protos' when making changes to proto files" && false))

check-api-descriptors: protos ## check that protobuf changes aren't present.
	@echo "$(WHALE) $@"
	@test -z "$$(git status --short | grep ".pb.txt" | tee /dev/stderr)" || \
		((git diff $$(find . -name '*.pb.txt') | cat) && \
		(echo "$(ONI) please run 'make protos' when making changes to proto files and check-in the generated descriptor file changes" && false))

proto-fmt: ## check format of proto files
	@echo "$(WHALE) $@"
	@test -z "$$(find . -path ./vendor -prune -o -path ./protobuf/google/rpc -prune -o -name '*.proto' -type f -exec grep -Hn -e "^ " {} \; | tee /dev/stderr)" || \
		(echo "$(ONI) please indent proto files with tabs only" && false)
	@test -z "$$(find . -path ./vendor -prune -o -name '*.proto' -type f -exec grep -Hn "Meta meta = " {} \; | grep -v '(gogoproto.nullable) = false' | tee /dev/stderr)" || \
		(echo "$(ONI) meta fields in proto files must have option (gogoproto.nullable) = false" && false)

build: ## build the go packages
	@echo "$(WHALE) $@"
	@$(GO) build ${DEBUG_GO_GCFLAGS} ${GO_GCFLAGS} ${GO_BUILD_FLAGS} ${EXTRA_FLAGS} ${GO_LDFLAGS} ${PACKAGES}

test: ## run tests, except integration tests and tests that require root
	@echo "$(WHALE) $@"
	@$(GOTEST) ${TESTFLAGS} ${PACKAGES}

root-test: ## run tests, except integration tests
	@echo "$(WHALE) $@"
	@$(GOTEST) ${TESTFLAGS} ${TEST_REQUIRES_ROOT_PACKAGES} -test.root

integration: ## run integration tests
	@echo "$(WHALE) $@"
	@cd "${ROOTDIR}/integration/client" && $(GO) mod download && $(GOTEST) -v ${TESTFLAGS} -test.root -parallel ${TESTFLAGS_PARALLEL} .

# TODO integrate cri integration bucket with coverage
bin/cri-integration.test:
	@echo "$(WHALE) $@"
	@$(GO) test -c ./integration -o bin/cri-integration.test

cri-integration: binaries bin/cri-integration.test ## run cri integration tests
	@echo "$(WHALE) $@"
	@bash -x ./script/test/cri-integration.sh
	@rm -rf bin/cri-integration.test

# build runc shimv2 with failpoint control, only used by integration test
bin/containerd-shim-runc-fp-v1: integration/failpoint/cmd/containerd-shim-runc-fp-v1 FORCE
	@echo "$(WHALE) $@"
	@CGO_ENABLED=${SHIM_CGO_ENABLED} $(GO) build ${GO_BUILD_FLAGS} -o $@ ${SHIM_GO_LDFLAGS} ${GO_TAGS} ./integration/failpoint/cmd/containerd-shim-runc-fp-v1

# build CNI bridge plugin wrapper with failpoint support, only used by integration test
bin/cni-bridge-fp: integration/failpoint/cmd/cni-bridge-fp FORCE
	@echo "$(WHALE) $@"
	@$(GO) build ${GO_BUILD_FLAGS} -o $@ ./integration/failpoint/cmd/cni-bridge-fp

benchmark: ## run benchmarks tests
	@echo "$(WHALE) $@"
	@$(GO) test ${TESTFLAGS} -bench . -run Benchmark -test.root

FORCE:

define BUILD_BINARY
@echo "$(WHALE) $@"
@$(GO) build ${DEBUG_GO_GCFLAGS} ${GO_GCFLAGS} ${GO_BUILD_FLAGS} -o $@ ${GO_LDFLAGS} ${GO_TAGS}  ./$<
endef

# Build a binary from a cmd.
bin/%: cmd/% FORCE
	$(call BUILD_BINARY)

bin/containerd-shim: cmd/containerd-shim FORCE # set !cgo and omit pie for a static shim build: https://github.com/golang/go/issues/17789#issuecomment-258542220
	@echo "$(WHALE) $@"
	@CGO_ENABLED=${SHIM_CGO_ENABLED} $(GO) build ${GO_BUILD_FLAGS} -o $@ ${SHIM_GO_LDFLAGS} ${GO_TAGS} ./cmd/containerd-shim

bin/containerd-shim-runc-v1: cmd/containerd-shim-runc-v1 FORCE # set !cgo and omit pie for a static shim build: https://github.com/golang/go/issues/17789#issuecomment-258542220
	@echo "$(WHALE) $@"
	@CGO_ENABLED=${SHIM_CGO_ENABLED} $(GO) build ${GO_BUILD_FLAGS} -o $@ ${SHIM_GO_LDFLAGS} ${GO_TAGS} ./cmd/containerd-shim-runc-v1

bin/containerd-shim-runc-v2: cmd/containerd-shim-runc-v2 FORCE # set !cgo and omit pie for a static shim build: https://github.com/golang/go/issues/17789#issuecomment-258542220
	@echo "$(WHALE) $@"
	@CGO_ENABLED=${SHIM_CGO_ENABLED} $(GO) build ${GO_BUILD_FLAGS} -o $@ ${SHIM_GO_LDFLAGS} ${GO_TAGS} ./cmd/containerd-shim-runc-v2

binaries: $(BINARIES) ## build binaries
	@echo "$(WHALE) $@"

man: mandir $(addprefix man/,$(MANPAGES))
	@echo "$(WHALE) $@"

mandir:
	@mkdir -p man

# Kept for backwards compatibility
genman: man/containerd.8 man/ctr.8

man/containerd.8: FORCE
	@echo "$(WHALE) $@"
	$(GO) run -mod=readonly ${GO_TAGS} cmd/gen-manpages/main.go $(@F) $(@D)

man/ctr.8: FORCE
	@echo "$(WHALE) $@"
	$(GO) run -mod=readonly ${GO_TAGS} cmd/gen-manpages/main.go $(@F) $(@D)

man/%: docs/man/%.md FORCE
	@echo "$(WHALE) $@"
	go-md2man -in "$<" -out "$@"

define installmanpage
$(INSTALL) -d $(DESTDIR)$(MANDIR)/man$(2);
gzip -c $(1) >$(DESTDIR)$(MANDIR)/man$(2)/$(3).gz;
endef

install-man: man
	@echo "$(WHALE) $@"
	$(foreach manpage,$(addprefix man/,$(MANPAGES)), $(call installmanpage,$(manpage),$(subst .,,$(suffix $(manpage))),$(notdir $(manpage))))


releases/$(RELEASE).tar.gz: $(BINARIES)
	@echo "$(WHALE) $@"
	@rm -rf releases/$(RELEASE) releases/$(RELEASE).tar.gz
	@$(INSTALL) -d releases/$(RELEASE)/bin
	@$(INSTALL) $(BINARIES) releases/$(RELEASE)/bin
	@tar -czf releases/$(RELEASE).tar.gz -C releases/$(RELEASE) bin
	@rm -rf releases/$(RELEASE)

release: releases/$(RELEASE).tar.gz
	@echo "$(WHALE) $@"
	@cd releases && sha256sum $(RELEASE).tar.gz >$(RELEASE).tar.gz.sha256sum

# install of cri deps into release output directory
ifeq ($(GOOS),windows)
install-cri-deps: $(BINARIES)
	$(INSTALL) -d $(CRIDIR)
	DESTDIR=$(CRIDIR) script/setup/install-cni-windows
	cp bin/* $(CRIDIR)
else
install-cri-deps: $(BINARIES)
	@rm -rf ${CRIDIR}
	@$(INSTALL) -d ${CRIDIR}/usr/local/bin
	@$(INSTALL) -D -m 755 bin/* ${CRIDIR}/usr/local/bin
	@$(INSTALL) -d ${CRIDIR}/opt/containerd/cluster
	@cp -r contrib/gce ${CRIDIR}/opt/containerd/cluster/
	@$(INSTALL) -d ${CRIDIR}/etc/systemd/system
	@$(INSTALL) -m 644 containerd.service ${CRIDIR}/etc/systemd/system
	echo "CONTAINERD_VERSION: '$(VERSION:v%=%)'" | tee ${CRIDIR}/opt/containerd/cluster/version

	DESTDIR=$(CRIDIR) script/setup/install-runc
	DESTDIR=$(CRIDIR) script/setup/install-cni
	DESTDIR=$(CRIDIR) script/setup/install-critools
	DESTDIR=$(CRIDIR) script/setup/install-imgcrypt

	@$(INSTALL) -d $(CRIDIR)/bin

=== vendor/github.com/containerd/nri/Makefile ===
#   Copyright The containerd Authors.

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.

all:
	go build -v

=== debian/changelog ===
containerd (1.6.24~ds1-1ubuntu1.3) noble-security; urgency=medium

  * No change rebuild due to golang-1.22 update

 -- Evan Caville <evan.caville@canonical.com>  Fri, 20 Jun 2025 16:52:25 +1000

containerd (1.6.24~ds1-1ubuntu1.2) noble-security; urgency=medium

  * No change rebuild due to golang-1.22 update

 -- Evan Caville <evan.caville@canonical.com>  Thu, 24 Oct 2024 10:13:03 +1000

containerd (1.6.24~ds1-1ubuntu1.1) noble-security; urgency=medium

  * No change rebuild due to golang-1.22 update

 -- Nishit Majithia <nishit.majithia@canonical.com>  Tue, 16 Jul 2024 12:20:19 +0530

containerd (1.6.24~ds1-1ubuntu1) noble; urgency=medium

  * Merge with Debian unstable (LP: #2040374). Remaining changes:
    - d/control: remove the binary paragraph for containerd.
    - d/containerd.*: remove all packaging related files associated to the
      containerd binary package.
    - d/tests/{cri-integration,integration}: remove since they depend on the
      containerd binary package which is not provided by this source package
      anymore.
    - d/rules: remove execute_after_dh_auto_build target, it is changing
      content in the containerd binary package. Also avoid installing binaries
      in the library package.
    - d/golang-github-containerd-containerd-dev.install: remove this file, it
      is causing a FTBFS, no need to have it in place, the library files are
      already installed correctly without it.
    - d/golang-github-containerd-containerd-dev.docs: install NOTICE file to
      be compliant with the Apache 2 license.
  * Dropped:
    - d/p/0009-Skip-test-trying-to-set-OOM-score.patch: fix FTBFS.
      [Not needed anymore]

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Fri, 12 Jan 2024 19:00:15 -0300

containerd (1.6.24~ds1-1) unstable; urgency=medium

  * New upstream version 1.6.24~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 06 Nov 2023 18:25:11 +0800

containerd (1.6.20~ds1-2) unstable; urgency=medium

  * Backport patch for Go1.21
  * Skip test adjusting oom score when initial is negative
  * Add pkg.containerd.onlydev build profile.
    To reduce delta with Ubuntu

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 23 Aug 2023 13:48:17 +0800

containerd (1.6.20~ds1-1ubuntu2) mantic; urgency=medium

  * d/p/0009-Skip-test-trying-to-set-OOM-score.patch: fix FTBFS.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Wed, 21 Jun 2023 23:07:52 -0300

containerd (1.6.20~ds1-1ubuntu1) mantic; urgency=medium

  * Merge from Debian unstable (LP: #2022390). Make src:containerd
    follow Debian and src:containerd-app is going to ship the application with
    vendorized dependencies so we can keep updating just the application across
    all supported releases.
  * Added changes:
    - d/control: remove the binary paragraph for containerd.
    - d/containerd.*: remove all packaging related files associated to the
      containerd binary package.
    - d/tests/{cri-integration,integration}: remove since they depend on the
      containerd binary package which is not provided by this source package
      anymore.
    - d/rules: remove execute_after_dh_auto_build target, it is changing
      content in the containerd binary package. Also avoid installing binaries
      in the library package.
    - d/golang-github-containerd-containerd-dev.install: remove this file, it
      is causing a FTBFS, no need to have it in place, the library files are
      already installed correctly without it.
    - d/golang-github-containerd-containerd-dev.docs: install NOTICE file to
      be compliant with the Apache 2 license.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Wed, 21 Jun 2023 11:53:33 -0300

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: containerd
 Section: admin
 Priority: optional
-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Tianon Gravi <tianon@debian.org>,
            Tim Potter <tpot@hpe.com>,
            Shengjing Zhu <zhsj@debian.org>,
@@ -76,26 +77,6 @@
 XS-Go-Import-Path: github.com/containerd/containerd
 Testsuite: autopkgtest-pkg-go
 
-Package: containerd
-Architecture: linux-any
-Breaks: docker.io (<< 1.12),
-Depends: runc (>= 0.1.0~),
-         ${misc:Depends},
-         ${shlibs:Depends},
-Suggests: containernetworking-plugins,
-Built-Using: ${misc:Built-Using},
-Description: open and reliable container runtime
- Containerd is an industry-standard container runtime with an emphasis on
- simplicity, robustness and portability. It is available as a daemon for
- Linux and Windows, which can manage the complete container life cycle of
- its host system: image transfer and storage, container execution and
- supervision, low-level storage and network attachments, etc.
- .
- Containerd is designed to be embedded into a larger system, rather than
- being used directly by developers or end-users.
- .
- This package contains the binaries.
-
 Package: golang-github-containerd-containerd-dev
 Architecture: all
 Section: golang

=== debian/rules ===
--- 
+++ 
@@ -27,23 +27,7 @@
 override_dh_auto_build:
 	dh_auto_build -- -ldflags '$(GO_LDFLAGS)'
 
-ifeq (,$(AUTOPKGTEST_TMP))
-execute_after_dh_auto_build:
-	mkdir -p man
-	make man/containerd-config.8
-	make man/containerd-config.toml.5
-	_build/bin/gen-manpages containerd.8 man
-	_build/bin/gen-manpages ctr.8 man
-	rm -vf _build/bin/gen-manpages
-
-	sed 's|/usr/local/bin|/usr/bin|' containerd.service > debian/containerd.service
-	mkdir -vp debian/bash-completion
-	install -m644 -T /usr/share/gocode/src/github.com/urfave/cli/autocomplete/bash_autocomplete \
-		debian/bash-completion/ctr
-	mkdir -vp debian/zsh-completion
-	sed 's|$$PROG|ctr|g' /usr/share/gocode/src/github.com/urfave/cli/autocomplete/zsh_autocomplete > \
-		debian/zsh-completion/_ctr
-endif
-
 override_dh_auto_install:
 	DH_GOLANG_EXCLUDES="$(EXCLUDES) $(EXTRA_EXCLUDES)" dh_auto_install
+	# Do not install binaries
+	rm -rf debian/golang-github-containerd-containerd-dev/usr/bin

=== debian/tests/control ===
Tests: build-only
Depends: dh-golang,
         golang-any,
         golang-github-containerd-containerd-dev,
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=filenamemangle=s%.*/v?(\d\S*)\.tar\.gz%@PACKAGE@-$1.tar.gz%,\
uversionmangle=s%(\d)-(rc|beta|alpha)\.?(\d*)$%$1~$2$3%,\
dversionmangle=s%[~+]ds\d*$%%,\
repacksuffix=~ds1 \
  https://github.com/containerd/containerd/tags .*/v?(1\.6\.\d\S*)\.tar\.gz

## containerd 1.7.18~ds1

=== debian/changelog ===
containerd (1.7.18~ds1-6) unstable; urgency=medium

  * debian/tests/build-only: Clarify and build in separate directory
  * containerd/zfs: Adjust import path for debian
  * add missing dependencies to the -dev package
  * Ensure most pkg/cri don't end up in the binary package
  * Add Breaks:
    - golang-github-containerd-imgcrypt-dev (<< 1.1.11-4)
    - golang-github-docker-docker-dev (<< 26.1)

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 04 Aug 2024 11:09:55 -0400

containerd (1.7.18~ds1-5) unstable; urgency=medium

  * install aufs, zfs as if it came from this package to work around cyclic dependencies
    (Closes: #1077319)
  * remove the 'build-only' autopkgtest

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 03 Aug 2024 10:22:27 -0400

containerd (1.7.18~ds1-4) unstable; urgency=medium

  * Team upload
  * Upload changes from experimental to unstable

 -- Mathias Gibbens <gibmat@debian.org>  Fri, 26 Jul 2024 02:50:31 +0000

containerd (1.7.18~ds1-3) experimental; urgency=medium

  * Depend on golang-opentelemetry-contrib-dev to fix FTBFS in dependent
    packages

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 09 Jul 2024 19:19:57 -0400

containerd (1.7.18~ds1-2) experimental; urgency=medium

  * Add forgotten bug closure in previous upload
  * 0011-allow-test-run-in-userns.patch: expand to another unit test

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 30 Jun 2024 20:00:55 -0400

containerd (1.7.18~ds1-1) experimental; urgency=medium

  * New upstream release, Closes: #1073550
    - Update / tighten dependencies, drop previously vendored libraries:
      - containerd/errdefs
      - containerd/imgcrypt
      - containerd/log
      - containerd/nri
      - k8s.io/cri-api
  * Avoid building contrib/fuzzer
  * Allow building against go-runc 1.1.0

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 30 Jun 2024 15:25:00 -0400

containerd (1.6.24~ds1-3) experimental; urgency=medium

  * Build against ttrpc in experimental

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 11 Jun 2024 08:25:41 -0400

containerd (1.6.24~ds1-2) unstable; urgency=medium

  * Refresh patches
  * Fix FTBFS when running test if running with unshare, Closes: #1070411
  * Remove leftover manpages in clean, Closes: #1044768
  * Rebuild to move systemd units into /usr, Closes: #1072079
  * Add myself as uploader.

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 11 Jun 2024 06:08:53 -0400

=== debian/control ===
--- 
+++ 
@@ -1,25 +1,29 @@
 Source: containerd
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
+Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Tianon Gravi <tianon@debian.org>,
            Tim Potter <tpot@hpe.com>,
            Shengjing Zhu <zhsj@debian.org>,
+           Reinhard Tartler <siretart@tauware.de>
 Build-Depends: debhelper-compat (= 13),
                dh-golang,
                go-md2man,
                golang-any,
                golang-github-blang-semver-dev,
-               golang-github-containerd-btrfs-dev (>= 0.0~git20200117.1539353~),
-               golang-github-containerd-cgroups-dev (>= 0.0~git20200817.7a3c009~),
+               golang-github-containerd-btrfs-dev (>= 2),
+               golang-github-containerd-cgroups-dev (>= 3),
                golang-github-containerd-console-dev,
                golang-github-containerd-continuity-dev (>= 0.0~git20190827.75bee3e~),
+               golang-github-containerd-errdefs-dev,
                golang-github-containerd-fifo-dev (>= 1.0.0~),
-               golang-github-containerd-go-cni-dev (>= 1.0.2~),
-               golang-github-containerd-go-runc-dev (>= 0.0~git20190226.7d11b49~),
-               golang-github-containerd-ttrpc-dev (>= 1.1.1~),
-               golang-github-containerd-typeurl-dev,
+               golang-github-containerd-go-cni-dev (>= 1.1.9),
+               golang-github-containerd-go-runc-dev (>= 1.1.0),
+               golang-github-containerd-imgcrypt-dev,
+               golang-github-containerd-log-dev,
+               golang-github-containerd-nri-dev,
+               golang-github-containerd-ttrpc-dev (>= 1.2),
+               golang-github-containerd-typeurl-dev (>= 2),
                golang-github-containernetworking-plugins-dev,
                golang-github-containers-ocicrypt-dev,
                golang-github-coreos-bbolt-dev,
@@ -29,7 +33,9 @@
                golang-github-docker-go-metrics-dev,
                golang-github-docker-go-units-dev,
                golang-github-emicklei-go-restful-dev,
+               golang-github-felixge-httpsnoop-dev,
                golang-github-fsnotify-fsnotify-dev,
+               golang-github-go-jose-go-jose.v3-dev,
                golang-github-go-logr-logr-dev,
                golang-github-gogo-googleapis-dev (>= 1.4.0~),
                golang-github-gogo-protobuf-dev (>= 1.3.0~),
@@ -42,6 +48,9 @@
                golang-github-imdario-mergo-dev,
                golang-github-intel-goresctrl-dev,
                golang-github-klauspost-compress-dev,
+               golang-github-klauspost-cpuid-dev,
+               golang-github-kubernetes-cri-api-dev (>> 0.27),
+               golang-github-minio-sha256-simd-dev,
                golang-github-moby-locker-dev,
                golang-github-moby-spdystream-dev,
                golang-github-moby-sys-dev (>= 0.0~git20220215.b8d8fab~),
@@ -49,6 +58,7 @@
                golang-github-opencontainers-image-spec-dev (>= 1.1.0~rc2-2~),
                golang-github-opencontainers-runc-dev (>= 0.1.0~),
                golang-github-opencontainers-runtime-spec-dev,
+               golang-github-opencontainers-runtime-tools-dev,
                golang-github-opencontainers-selinux-dev,
                golang-github-pelletier-go-toml-dev,
                golang-github-pkg-errors-dev,
@@ -59,6 +69,7 @@
                golang-github-urfave-cli-dev (>= 1.22.2-4~),
                golang-github-vishvananda-netlink-dev,
                golang-go-zfs-dev,
+               golang-golang-x-mod-dev,
                golang-golang-x-net-dev,
                golang-golang-x-sync-dev,
                golang-golang-x-sys-dev,
@@ -66,9 +77,11 @@
                golang-google-grpc-dev (>= 1.30),
                golang-gopkg-inf.v0-dev,
                golang-k8s-klog-dev (>= 2.30.0~),
+               golang-k8s-sigs-json-dev,
                golang-k8s-sigs-structured-merge-diff-dev,
                golang-k8s-sigs-yaml-dev,
-               golang-opentelemetry-otel-dev,
+               golang-opentelemetry-contrib-dev,
+               golang-opentelemetry-otel-dev (>> 1.19)
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://containerd.io/
@@ -77,18 +90,43 @@
 XS-Go-Import-Path: github.com/containerd/containerd
 Testsuite: autopkgtest-pkg-go
 
+Package: containerd
+Build-Profiles: <!pkg.containerd.onlydev>
+Architecture: linux-any
+Breaks: docker.io (<< 1.12)
+Depends: runc (>= 0.1.0~), ${misc:Depends}, ${shlibs:Depends}
+Suggests: containernetworking-plugins
+Built-Using: ${misc:Built-Using}
+Description: open and reliable container runtime
+ Containerd is an industry-standard container runtime with an emphasis on
+ simplicity, robustness and portability. It is available as a daemon for
+ Linux and Windows, which can manage the complete container life cycle of
+ its host system: image transfer and storage, container execution and
+ supervision, low-level storage and network attachments, etc.
+ .
+ Containerd is designed to be embedded into a larger system, rather than
+ being used directly by developers or end-users.
+ .
+ This package contains the binaries.
+
 Package: golang-github-containerd-containerd-dev
 Architecture: all
 Section: golang
-Depends: golang-github-containerd-btrfs-dev (>= 0.0~git20200117.1539353~),
-         golang-github-containerd-cgroups-dev (>= 0.0~git20200817.7a3c009~),
+Breaks: golang-github-containerd-imgcrypt-dev (<< 1.1.11-4),
+        golang-github-docker-docker-dev (<< 26.1)
+Depends: golang-github-containerd-btrfs-dev (>= 2),
+         golang-github-containerd-cgroups-dev (>= 3),
          golang-github-containerd-console-dev,
          golang-github-containerd-continuity-dev (>= 0.0~git20190827.75bee3e~),
+         golang-github-containerd-errdefs-dev,
          golang-github-containerd-fifo-dev (>= 1.0.0~),
-         golang-github-containerd-go-cni-dev (>= 1.0.2~),
-         golang-github-containerd-go-runc-dev (>= 0.0~git20190226.7d11b49~),
-         golang-github-containerd-ttrpc-dev (>= 1.1.1~),
-         golang-github-containerd-typeurl-dev,
+         golang-github-containerd-go-cni-dev (>= 1.1.9),
+         golang-github-containerd-go-runc-dev (>= 1.1.0),
+         golang-github-containerd-imgcrypt-dev,
+         golang-github-containerd-log-dev,
+         golang-github-containerd-nri-dev,
+         golang-github-containerd-ttrpc-dev (>= 1.2),
+         golang-github-containerd-typeurl-dev (>= 2),
          golang-github-containernetworking-plugins-dev,
          golang-github-coreos-bbolt-dev,
          golang-github-docker-go-events-dev,
@@ -103,6 +141,8 @@
          golang-github-imdario-mergo-dev,
          golang-github-intel-goresctrl-dev,
          golang-github-klauspost-compress-dev,
+         golang-github-kubernetes-cri-api-dev (>> 0.27),
+         golang-github-minio-sha256-simd-dev,
          golang-github-moby-locker-dev,
          golang-github-moby-sys-dev (>= 0.0~git20220215.b8d8fab~),
          golang-github-opencontainers-go-digest-dev (>= 1.0.0~),
@@ -113,13 +153,16 @@
          golang-github-pelletier-go-toml-dev,
          golang-github-prometheus-client-golang-dev,
          golang-github-sirupsen-logrus-dev,
+         golang-github-tchap-go-patricia-dev,
          golang-github-urfave-cli-dev (>= 1.22.2~),
+         golang-go-zfs-dev,
          golang-golang-x-net-dev,
          golang-golang-x-sync-dev,
          golang-golang-x-sys-dev,
          golang-google-grpc-dev (>= 1.30),
-         golang-opentelemetry-otel-dev,
-         ${misc:Depends},
+         golang-opentelemetry-contrib-dev,
+         golang-opentelemetry-otel-dev (>> 1.19),
+         ${misc:Depends}
 Description: open and reliable container runtime (development files)
  Containerd is an industry-standard container runtime with an emphasis on
  simplicity, robustness and portability. It is available as a daemon for

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

PKG        := github.com/containerd/containerd
GO_LDFLAGS += -X $(PKG)/version.Version=$(DEB_VERSION_UPSTREAM)
GO_LDFLAGS += -X $(PKG)/version.Revision=$(DEB_VERSION)

EXCLUDES += cmd/protoc-gen-gogoctrd cmd/containerd-stress
EXCLUDES += runtime/v2/example/cmd
EXCLUDES += integration
EXCLUDES += contrib/fuzz

# pkg/cri has k8s dependencies, not all of which are in Debian yet
EXCLUDES += pkg/cri

# Exclude extra files in -dev package to make it slimmer.
EXTRA_EXCLUDES += vendor
EXTRA_EXCLUDES += $(wildcard cmd/*/*.go)

export DH_GOLANG_EXCLUDES := $(EXCLUDES)

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_auto_build:
	dh_auto_build -- -ldflags '$(GO_LDFLAGS)'

execute_before_dh_auto_build:
	# delete sources we don't want to have included in the resulting binary packages
	rm -rfv _build/src/github.com/containerd/containerd/pkg/cri/*
	rm -fv _build/src/github.com/containerd/containerd/cmd/containerd/builtins/cri.go

ifeq (,$(AUTOPKGTEST_TMP))
execute_after_dh_auto_build:
	mkdir -p man
	make man/containerd-config.8
	make man/containerd-config.toml.5
	_build/bin/gen-manpages containerd.8 man
	_build/bin/gen-manpages ctr.8 man
	rm -vf _build/bin/gen-manpages

	sed 's|/usr/local/bin|/usr/bin|' containerd.service > debian/containerd.service
	mkdir -vp debian/bash-completion
	install -m644 -T /usr/share/gocode/src/github.com/urfave/cli/autocomplete/bash_autocomplete \
		debian/bash-completion/ctr
	mkdir -vp debian/zsh-completion
	sed 's|$$PROG|ctr|g' /usr/share/gocode/src/github.com/urfave/cli/autocomplete/zsh_autocomplete > \
		debian/zsh-completion/_ctr
execute_after_dh_clean:
	rm -rvf man/containerd-config.8 man/containerd-config.toml.5 containerd.8 man ctr.8 man
endif

override_dh_auto_install:
	DH_GOLANG_EXCLUDES="$(EXCLUDES) $(EXTRA_EXCLUDES)" dh_auto_install

# install aufs, zfs as if it came from this package to work around cyclic dependencies
execute_after_dh_auto_install:
	cp -vrf vendor/github.com/containerd/zfs vendor/github.com/containerd/aufs \
	  debian/tmp/usr/share/gocode/src/github.com/containerd/

=== debian/tests/control ===
# This test is currenty known to fail in containers for a number of reasons:
# - for missing binary "runc-fp" (??)
# - permission errors when trying to start containers
# - failing to mount procfs
# - failing to load cni configs
Tests: integration
Depends: ca-certificates, containerd, lsof, @builddeps@
Restrictions: allow-stderr, needs-root, needs-internet, isolation-machine, flaky
# Integration test uses k8s.gcr.io/pause:3.5 image
# See the supported architectures for this image:
# $ curl https://k8s.gcr.io/v2/pause/manifests/3.2
Architecture: amd64, arm64, armel, armhf, ppc64el, s390x

# This test is currenty known to fail in containers for a number of reasons:
# - permission errors when trying manipulate network interfaces
Tests: cri-integration
Depends: ca-certificates,
         containerd,
         containernetworking-plugins,
         procps,
         @builddeps@
Restrictions: allow-stderr, needs-root, needs-internet, isolation-machine, flaky
Architecture: amd64, arm64, ppc64el

Tests: build-only
Depends: dh-golang, golang-any, golang-github-containerd-containerd-dev
Restrictions: allow-stderr
